# This script segment is generated automatically by AutoPilot

set id 0
set name fir_hw_mul_24s_21s_44_6
set corename simcore_mul
set op mul
set stage_num 6
set registered_input 1
set in0_width 24
set in0_signed 1
set in1_width 21
set in1_signed 1
set out_width 44
if {${::AESL::PGuard_simmodel_gen}} {
if {[info proc ap_gen_simcore_mul] == "ap_gen_simcore_mul"} {
eval "ap_gen_simcore_mul { \
    id ${id} \
    name ${name} \
    corename ${corename} \
    op ${op} \
    reset_level 1 \
    sync_rst true \
    stage_num ${stage_num} \
    registered_input ${registered_input} \
    in0_width ${in0_width} \
    in0_signed ${in0_signed} \
    in1_width ${in1_width} \
    in1_signed ${in1_signed} \
    out_width ${out_width} \
}"
} else {
puts "@W \[IMPL-100\] Cannot find ap_gen_simcore_mul, check your AutoPilot builtin lib"
}
}


if {${::AESL::PGuard_rtl_comp_handler}} {
	::AP::rtl_comp_handler ${name}
}


set op mul
set corename Mul6S
if {${::AESL::PGuard_autocg_gen} && ${::AESL::PGuard_autocg_ipmgen}} {
if {[info proc ::AESL_LIB_VIRTEX::xil_gen_multicycle_mul] == "::AESL_LIB_VIRTEX::xil_gen_multicycle_mul"} {
eval "::AESL_LIB_VIRTEX::xil_gen_multicycle_mul { \
    id ${id} \
    name ${name} \
    corename ${corename} \
    op ${op} \
    reset_level 1 \
    sync_rst true \
    stage_num ${stage_num} \
    registered_input ${registered_input} \
    in0_width ${in0_width} \
    in0_signed ${in0_signed} \
    in1_width ${in1_width} \
    in1_signed ${in1_signed} \
    out_width ${out_width} \
}"
} else {
puts "@W \[IMPL-101\] Cannot find ::AESL_LIB_VIRTEX::xil_gen_multicycle_mul, check your platform lib"
}
}


set id 1
set name fir_hw_add_51ns_51s_51_2
set corename simcore_add
set op add
set stage_num 2
set registered_input 1
set in0_width 51
set in0_signed 0
set in1_width 51
set in1_signed 1
set out_width 51
if {${::AESL::PGuard_simmodel_gen}} {
if {[info proc ap_gen_simcore_add] == "ap_gen_simcore_add"} {
eval "ap_gen_simcore_add { \
    id ${id} \
    name ${name} \
    corename ${corename} \
    op ${op} \
    reset_level 1 \
    sync_rst true \
    stage_num ${stage_num} \
    registered_input ${registered_input} \
    in0_width ${in0_width} \
    in0_signed ${in0_signed} \
    in1_width ${in1_width} \
    in1_signed ${in1_signed} \
    out_width ${out_width} \
}"
} else {
puts "@W \[IMPL-100\] Cannot find ap_gen_simcore_add, check your AutoPilot builtin lib"
}
}


if {${::AESL::PGuard_rtl_comp_handler}} {
	::AP::rtl_comp_handler ${name}
}


set op add
set corename AddSubnS
if {${::AESL::PGuard_autocg_gen} && ${::AESL::PGuard_autocg_ipmgen}} {
if {[info proc ::AESL_LIB_VIRTEX::xil_gen_pipeaddsub] == "::AESL_LIB_VIRTEX::xil_gen_pipeaddsub"} {
eval "::AESL_LIB_VIRTEX::xil_gen_pipeaddsub { \
    id ${id} \
    name ${name} \
    corename ${corename} \
    op ${op} \
    reset_level 1 \
    sync_rst true \
    stage_num ${stage_num} \
    registered_input ${registered_input} \
    in0_width ${in0_width} \
    in0_signed ${in0_signed} \
    in1_width ${in1_width} \
    in1_signed ${in1_signed} \
    out_width ${out_width} \
}"
} else {
puts "@W \[IMPL-101\] Cannot find ::AESL_LIB_VIRTEX::xil_gen_pipeaddsub, check your platform lib"
}
}


# Memory (RAM/ROM)  definition:
set ID 3
set MemName fir_hw_array_all
set CoreName ap_simcore_mem
set PortList { 2 3 }
set DataWd 24
set AddrRange 256
set AddrWd 8
set impl_style block
set TrueReset 0
set IsROM 0
set ROMData { }
set HasInitializer 1
set Initializer $ROMData
set NumOfStage 2
set DelayBudget 2.39
set ClkPeriod 5
set RegisteredInput 0
if {${::AESL::PGuard_simmodel_gen}} {
if {[info proc ap_gen_simcore_mem] == "ap_gen_simcore_mem"} {
    eval "ap_gen_simcore_mem { \
    id ${ID} \
    name ${MemName} \
    corename ${CoreName}  \
    op mem \
    reset_level 1 \
    sync_rst true \
    stage_num 2 \
    registered_input ${RegisteredInput} \
    port_num 2 \
    port_list \{${PortList}\} \
    data_wd ${DataWd} \
    addr_wd ${AddrWd} \
    addr_range ${AddrRange} \
    style ${impl_style} \
    true_reset ${TrueReset} \
    delay_budget ${DelayBudget} \
    clk_period ${ClkPeriod} \
    HasInitializer ${HasInitializer} \
    rom_data \{${ROMData}\} \
 } "
} else {
    puts "@W \[IMPL-102\] Cannot find ap_gen_simcore_mem, check your platform lib"
}
}


if {${::AESL::PGuard_rtl_comp_handler}} {
  ::AP::rtl_comp_handler $MemName
}


set CoreName RAM
if {${::AESL::PGuard_autocg_gen} && ${::AESL::PGuard_autocg_ipmgen}} {
if {[info proc ::AESL_LIB_VIRTEX::xil_gen_RAM] == "::AESL_LIB_VIRTEX::xil_gen_RAM"} {
    eval "::AESL_LIB_VIRTEX::xil_gen_RAM { \
    id ${ID} \
    name ${MemName} \
    corename ${CoreName}  \
    op mem \
    reset_level 1 \
    sync_rst true \
    stage_num 2 \
    registered_input ${RegisteredInput} \
    port_num 2 \
    port_list \{${PortList}\} \
    data_wd ${DataWd} \
    addr_wd ${AddrWd} \
    addr_range ${AddrRange} \
    style ${impl_style} \
    true_reset ${TrueReset} \
    delay_budget ${DelayBudget} \
    clk_period ${ClkPeriod} \
    HasInitializer ${HasInitializer} \
    rom_data \{${ROMData}\} \
 } "
  } else {
    puts "@W \[IMPL-104\] Cannot find ::AESL_LIB_VIRTEX::xil_gen_RAM, check your platform lib"
  }
}


# Memory (RAM/ROM)  definition:
set ID 4
set MemName fir_hw_coeff_hw
set CoreName ap_simcore_mem
set PortList { 1 }
set DataWd 21
set AddrRange 128
set AddrWd 7
set TrueReset 0
set IsROM 1
set ROMData { "000000000011001011010" "111111111101010000110" "111111111010100001101" "111111110101101101011" "111111101110100011100" "111111100100101101101" "111111010111110101100" "111111000111101001100" "111110110011111111110" "111110011100111001001" "111110000010100011000" "111101100101011001101" "111101000110001000100" "111100100101101010101" "111100000101001010001" "111011100101111100111" "111011001001100011001" "111010110001100001100" "111010011111011100101" "111010010100110010110" "111010010010110110110" "111010011010100111111" "111010101100101101100" "111011001001010000100" "111011101111111001110" "111100011111101101101" "111101010111001100110" "111110010100010110110" "111111010100101100111" "000000010101011010001" "000001010011011010010" "000010001011100100110" "000010111010110111101" "000011011110100011011" "000011110100010110011" "000011111010100111111" "000011110000100001010" "000011010110000100110" "000010101100010001011" "000001110101000100001" "000000110011010101000" "111111101010110000010" "111110011111101101001" "111101010111000000100" "111100010101101110000" "111011100000110101111" "111010111101000100101" "111010101110011111111" "111010111000010110111" "111011011100110100000" "111100011100110001111" "111101110111110100111" "111111101100000111100" "000001110110011101111" "000100010010011100010" "000110111010100010110" "001001101000011100111" "001100010101010101000" "001110111010001000110" "010001010000000000001" "010011010000100011000" "010100110110001110011" "010101111100100110011" "010110100000100101001" "010110100000100101001" "010101111100100110011" "010100110110001110011" "010011010000100011000" "010001010000000000001" "001110111010001000110" "001100010101010101000" "001001101000011100111" "000110111010100010110" "000100010010011100010" "000001110110011101111" "111111101100000111100" "111101110111110100111" "111100011100110001111" "111011011100110100000" "111010111000010110111" "111010101110011111111" "111010111101000100101" "111011100000110101111" "111100010101101110000" "111101010111000000100" "111110011111101101001" "111111101010110000010" "000000110011010101000" "000001110101000100001" "000010101100010001011" "000011010110000100110" "000011110000100001010" "000011111010100111111" "000011110100010110011" "000011011110100011011" "000010111010110111101" "000010001011100100110" "000001010011011010010" "000000010101011010001" "111111010100101100111" "111110010100010110110" "111101010111001100110" "111100011111101101101" "111011101111111001110" "111011001001010000100" "111010101100101101100" "111010011010100111111" "111010010010110110110" "111010010100110010110" "111010011111011100101" "111010110001100001100" "111011001001100011001" "111011100101111100111" "111100000101001010001" "111100100101101010101" "111101000110001000100" "111101100101011001101" "111110000010100011000" "111110011100111001001" "111110110011111111110" "111111000111101001100" "111111010111110101100" "111111100100101101101" "111111101110100011100" "111111110101101101011" "111111111010100001101" "111111111101010000110" "000000000011001011010" }
set HasInitializer 1
set Initializer $ROMData
set NumOfStage 2
set DelayBudget 2.39
set ClkPeriod 5
set RegisteredInput 0
if {${::AESL::PGuard_simmodel_gen}} {
if {[info proc ap_gen_simcore_mem] == "ap_gen_simcore_mem"} {
    eval "ap_gen_simcore_mem { \
    id ${ID} \
    name ${MemName} \
    corename ${CoreName}  \
    op mem \
    reset_level 1 \
    sync_rst true \
    stage_num 2 \
    registered_input ${RegisteredInput} \
    port_num 1 \
    port_list \{${PortList}\} \
    data_wd ${DataWd} \
    addr_wd ${AddrWd} \
    addr_range ${AddrRange} \
    true_reset ${TrueReset} \
    delay_budget ${DelayBudget} \
    clk_period ${ClkPeriod} \
    HasInitializer ${HasInitializer} \
    rom_data \{${ROMData}\} \
 } "
} else {
    puts "@W \[IMPL-102\] Cannot find ap_gen_simcore_mem, check your platform lib"
}
}


if {${::AESL::PGuard_rtl_comp_handler}} {
  ::AP::rtl_comp_handler $MemName
}


set CoreName ROM_nP
if {${::AESL::PGuard_autocg_gen} && ${::AESL::PGuard_autocg_ipmgen}} {
if {[info proc ::AESL_LIB_VIRTEX::xil_gen_ROM] == "::AESL_LIB_VIRTEX::xil_gen_ROM"} {
    eval "::AESL_LIB_VIRTEX::xil_gen_ROM { \
    id ${ID} \
    name ${MemName} \
    corename ${CoreName}  \
    op mem \
    reset_level 1 \
    sync_rst true \
    stage_num 2 \
    registered_input ${RegisteredInput} \
    port_num 1 \
    port_list \{${PortList}\} \
    data_wd ${DataWd} \
    addr_wd ${AddrWd} \
    addr_range ${AddrRange} \
    true_reset ${TrueReset} \
    delay_budget ${DelayBudget} \
    clk_period ${ClkPeriod} \
    HasInitializer ${HasInitializer} \
    rom_data \{${ROMData}\} \
 } "
  } else {
    puts "@W \[IMPL-104\] Cannot find ::AESL_LIB_VIRTEX::xil_gen_ROM, check your platform lib"
  }
}


# clear list
if {${::AESL::PGuard_autoexp_gen}} {
    cg_default_interface_gen_dc_begin
    cg_default_interface_gen_bundle_begin
    AESL_LIB_XILADAPTER::native_axis_begin
}

# Direct connection:
if {${::AESL::PGuard_autoexp_gen}} {
eval "cg_default_interface_gen_dc { \
    id 5 \
    name input_l_V \
    type other \
    dir I \
    reset_level 1 \
    sync_rst true \
    corename dc_input_l_V \
    op interface \
    ports { input_l_V { I 24 vector } input_l_V_ap_vld { I 1 bit } input_l_V_ap_ack { O 1 bit } } \
} "
}

# Direct connection:
if {${::AESL::PGuard_autoexp_gen}} {
eval "cg_default_interface_gen_dc { \
    id 6 \
    name input_r_V \
    type other \
    dir I \
    reset_level 1 \
    sync_rst true \
    corename dc_input_r_V \
    op interface \
    ports { input_r_V { I 24 vector } input_r_V_ap_vld { I 1 bit } input_r_V_ap_ack { O 1 bit } } \
} "
}

# Direct connection:
if {${::AESL::PGuard_autoexp_gen}} {
eval "cg_default_interface_gen_dc { \
    id 7 \
    name res_l_V \
    type other \
    dir O \
    reset_level 1 \
    sync_rst true \
    corename dc_res_l_V \
    op interface \
    ports { res_l_V { O 24 vector } res_l_V_ap_vld { O 1 bit } res_l_V_ap_ack { I 1 bit } } \
} "
}

# Direct connection:
if {${::AESL::PGuard_autoexp_gen}} {
eval "cg_default_interface_gen_dc { \
    id 8 \
    name res_r_V \
    type other \
    dir O \
    reset_level 1 \
    sync_rst true \
    corename dc_res_r_V \
    op interface \
    ports { res_r_V { O 24 vector } res_r_V_ap_vld { O 1 bit } res_r_V_ap_ack { I 1 bit } } \
} "
}


# Adapter definition:
set PortName ap_clk
set DataWd 1 
if {${::AESL::PGuard_autoexp_gen}} {
if {[info proc cg_default_interface_gen_clock] == "cg_default_interface_gen_clock"} {
eval "cg_default_interface_gen_clock { \
    id -1 \
    name ${PortName} \
    reset_level 1 \
    sync_rst true \
    corename apif_ap_clk \
    data_wd ${DataWd} \
    op interface \
}"
} else {
puts "@W \[IMPL-113\] Cannot find bus interface model in the library. Ignored generation of bus interface for '${PortName}'"
}
}


# Adapter definition:
set PortName ap_rst
set DataWd 1 
if {${::AESL::PGuard_autoexp_gen}} {
if {[info proc cg_default_interface_gen_reset] == "cg_default_interface_gen_reset"} {
eval "cg_default_interface_gen_reset { \
    id -2 \
    name ${PortName} \
    reset_level 1 \
    sync_rst true \
    corename apif_ap_rst \
    data_wd ${DataWd} \
    op interface \
}"
} else {
puts "@W \[IMPL-114\] Cannot find bus interface model in the library. Ignored generation of bus interface for '${PortName}'"
}
}



# merge
if {${::AESL::PGuard_autoexp_gen}} {
    cg_default_interface_gen_dc_end
    cg_default_interface_gen_bundle_end
    AESL_LIB_XILADAPTER::native_axis_end
}


